package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class AttCertIssuer extends ASN1Encodable implements ASN1Choice {
   ASN1Encodable obj;
   DERObject choiceObj;

   public static AttCertIssuer getInstance(Object obj) {
      if (obj instanceof AttCertIssuer) {
         return (AttCertIssuer)obj;
      } else if (obj instanceof V2Form) {
         return new AttCertIssuer(V2Form.getInstance(obj));
      } else if (obj instanceof GeneralNames) {
         return new AttCertIssuer((GeneralNames)obj);
      } else if (obj instanceof ASN1TaggedObject) {
         return new AttCertIssuer(V2Form.getInstance((ASN1TaggedObject)obj, false));
      } else if (obj instanceof ASN1Sequence) {
         return new AttCertIssuer(GeneralNames.getInstance(obj));
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
      }
   }

   public static AttCertIssuer getInstance(ASN1TaggedObject obj, boolean explicit) {
      return getInstance(obj.getObject());
   }

   public AttCertIssuer(GeneralNames names) {
      this.obj = names;
      this.choiceObj = names.getDERObject();
   }

   public AttCertIssuer(V2Form v2Form) {
      AttCertIssuer var10000 = this;
      super();
      this.obj = v2Form;
      DERTaggedObject var2;
      var2 = new DERTaggedObject.<init>(false, 0, v2Form);
      var10000.choiceObj = var2;
   }

   public ASN1Encodable getIssuer() {
      return this.obj;
   }

   public DERObject toASN1Object() {
      return this.choiceObj;
   }
}
